Index: lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/scriptaculous/slider.js
===================================================================
--- lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/scriptaculous/slider.js	(nonexistent)
+++ lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/scriptaculous/slider.js	(revision 4307)
@@ -0,0 +1,283 @@
+// Copyright (c) 2005 Marty Haught, Thomas Fuchs 
+//
+// See http://script.aculo.us for more info
+// 
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to
+// permit persons to whom the Software is furnished to do so, subject to
+// the following conditions:
+// 
+// The above copyright notice and this permission notice shall be
+// included in all copies or substantial portions of the Software.
+//
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+if(!Control) var Control = {};
+Control.Slider = Class.create();
+
+// options:
+//  axis: 'vertical', or 'horizontal' (default)
+//
+// callbacks:
+//  onChange(value)
+//  onSlide(value)
+Control.Slider.prototype = {
+  initialize: function(handle, track, options) {
+    var slider = this;
+    
+    if(handle instanceof Array) {
+      this.handles = handle.collect( function(e) { return $(e) });
+    } else {
+      this.handles = [$(handle)];
+    }
+    
+    this.track   = $(track);
+    this.options = options || {};
+
+    this.axis      = this.options.axis || 'horizontal';
+    this.increment = this.options.increment || 1;
+    this.step      = parseInt(this.options.step || '1');
+    this.range     = this.options.range || $R(0,1);
+    
+    this.value     = 0; // assure backwards compat
+    this.values    = this.handles.map( function() { return 0 });
+    this.spans     = this.options.spans ? this.options.spans.map(function(s){ return $(s) }) : false;
+    this.options.startSpan = $(this.options.startSpan || null);
+    this.options.endSpan   = $(this.options.endSpan || null);
+
+    this.restricted = this.options.restricted || false;
+
+    this.maximum   = this.options.maximum || this.range.end;
+    this.minimum   = this.options.minimum || this.range.start;
+
+    // Will be used to align the handle onto the track, if necessary
+    this.alignX = parseInt(this.options.alignX || '0');
+    this.alignY = parseInt(this.options.alignY || '0');
+    
+    this.trackLength = this.maximumOffset() - this.minimumOffset();
+    this.handleLength = this.isVertical() ? this.handles[0].offsetHeight : this.handles[0].offsetWidth;
+
+    this.active   = false;
+    this.dragging = false;
+    this.disabled = false;
+
+    if(this.options.disabled) this.setDisabled();
+
+    // Allowed values array
+    this.allowedValues = this.options.values ? this.options.values.sortBy(Prototype.K) : false;
+    if(this.allowedValues) {
+      this.minimum = this.allowedValues.min();
+      this.maximum = this.allowedValues.max();
+    }
+
+    this.eventMouseDown = this.startDrag.bindAsEventListener(this);
+    this.eventMouseUp   = this.endDrag.bindAsEventListener(this);
+    this.eventMouseMove = this.update.bindAsEventListener(this);
+
+    // Initialize handles in reverse (make sure first handle is active)
+    this.handles.each( function(h,i) {
+      i = slider.handles.length-1-i;
+      slider.setValue(parseFloat(
+        (slider.options.sliderValue instanceof Array ? 
+          slider.options.sliderValue[i] : slider.options.sliderValue) || 
+         slider.range.start), i);
+      Element.makePositioned(h); // fix IE
+      Event.observe(h, "mousedown", slider.eventMouseDown);
+    });
+    
+    Event.observe(this.track, "mousedown", this.eventMouseDown);
+    Event.observe(document, "mouseup", this.eventMouseUp);
+    Event.observe(document, "mousemove", this.eventMouseMove);
+    
+    this.initialized = true;
+  },
+  dispose: function() {
+    var slider = this;    
+    Event.stopObserving(this.track, "mousedown", this.eventMouseDown);
+    Event.stopObserving(document, "mouseup", this.eventMouseUp);
+    Event.stopObserving(document, "mousemove", this.eventMouseMove);
+    this.handles.each( function(h) {
+      Event.stopObserving(h, "mousedown", slider.eventMouseDown);
+    });
+  },
+  setDisabled: function(){
+    this.disabled = true;
+  },
+  setEnabled: function(){
+    this.disabled = false;
+  },  
+  getNearestValue: function(value){
+    if(this.allowedValues){
+      if(value >= this.allowedValues.max()) return(this.allowedValues.max());
+      if(value <= this.allowedValues.min()) return(this.allowedValues.min());
+      
+      var offset = Math.abs(this.allowedValues[0] - value);
+      var newValue = this.allowedValues[0];
+      this.allowedValues.each( function(v) {
+        var currentOffset = Math.abs(v - value);
+        if(currentOffset <= offset){
+          newValue = v;
+          offset = currentOffset;
+        } 
+      });
+      return newValue;
+    }
+    if(value > this.range.end) return this.range.end;
+    if(value < this.range.start) return this.range.start;
+    return value;
+  },
+  setValue: function(sliderValue, handleIdx){
+    if(!this.active) {
+      this.activeHandle    = this.handles[handleIdx];
+      this.activeHandleIdx = handleIdx;
+      this.updateStyles();
+    }
+    handleIdx = handleIdx || this.activeHandleIdx || 0;
+    if(this.initialized && this.restricted) {
+      if((handleIdx>0) && (sliderValue<this.values[handleIdx-1]))
+        sliderValue = this.values[handleIdx-1];
+      if((handleIdx < (this.handles.length-1)) && (sliderValue>this.values[handleIdx+1]))
+        sliderValue = this.values[handleIdx+1];
+    }
+    sliderValue = this.getNearestValue(sliderValue);
+    this.values[handleIdx] = sliderValue;
+    this.value = this.values[0]; // assure backwards compat
+    
+    this.handles[handleIdx].style[this.isVertical() ? 'top' : 'left'] = 
+      this.translateToPx(sliderValue);
+    
+    this.drawSpans();
+    if(!this.dragging || !this.event) this.updateFinished();
+  },
+  setValueBy: function(delta, handleIdx) {
+    this.setValue(this.values[handleIdx || this.activeHandleIdx || 0] + delta, 
+      handleIdx || this.activeHandleIdx || 0);
+  },
+  translateToPx: function(value) {
+    return Math.round(
+      ((this.trackLength-this.handleLength)/(this.range.end-this.range.start)) * 
+      (value - this.range.start)) + "px";
+  },
+  translateToValue: function(offset) {
+    return ((offset/(this.trackLength-this.handleLength) * 
+      (this.range.end-this.range.start)) + this.range.start);
+  },
+  getRange: function(range) {
+    var v = this.values.sortBy(Prototype.K); 
+    range = range || 0;
+    return $R(v[range],v[range+1]);
+  },
+  minimumOffset: function(){
+    return(this.isVertical() ? this.alignY : this.alignX);
+  },
+  maximumOffset: function(){
+    return(this.isVertical() ?
+      this.track.offsetHeight - this.alignY : this.track.offsetWidth - this.alignX);
+  },  
+  isVertical:  function(){
+    return (this.axis == 'vertical');
+  },
+  drawSpans: function() {
+    var slider = this;
+    if(this.spans)
+      $R(0, this.spans.length-1).each(function(r) { slider.setSpan(slider.spans[r], slider.getRange(r)) });
+    if(this.options.startSpan)
+      this.setSpan(this.options.startSpan,
+        $R(0, this.values.length>1 ? this.getRange(0).min() : this.value ));
+    if(this.options.endSpan)
+      this.setSpan(this.options.endSpan, 
+        $R(this.values.length>1 ? this.getRange(this.spans.length-1).max() : this.value, this.maximum));
+  },
+  setSpan: function(span, range) {
+    if(this.isVertical()) {
+      span.style.top = this.translateToPx(range.start);
+      span.style.height = this.translateToPx(range.end - range.start + this.range.start);
+    } else {
+      span.style.left = this.translateToPx(range.start);
+      span.style.width = this.translateToPx(range.end - range.start + this.range.start);
+    }
+  },
+  updateStyles: function() {
+    this.handles.each( function(h){ Element.removeClassName(h, 'selected') });
+    Element.addClassName(this.activeHandle, 'selected');
+  },
+  startDrag: function(event) {
+    if(Event.isLeftClick(event)) {
+      if(!this.disabled){
+        this.active = true;
+        
+        var handle = Event.element(event);
+        var pointer  = [Event.pointerX(event), Event.pointerY(event)];
+        if(handle==this.track) {
+          var offsets  = Position.cumulativeOffset(this.track); 
+          this.event = event;
+          this.setValue(this.translateToValue( 
+           (this.isVertical() ? pointer[1]-offsets[1] : pointer[0]-offsets[0])-(this.handleLength/2)
+          ));
+          var offsets  = Position.cumulativeOffset(this.activeHandle);
+          this.offsetX = (pointer[0] - offsets[0]);
+          this.offsetY = (pointer[1] - offsets[1]);
+        } else {
+          // find the handle (prevents issues with Safari)
+          while((this.handles.indexOf(handle) == -1) && handle.parentNode) 
+            handle = handle.parentNode;
+        
+          this.activeHandle    = handle;
+          this.activeHandleIdx = this.handles.indexOf(this.activeHandle);
+          this.updateStyles();
+        
+          var offsets  = Position.cumulativeOffset(this.activeHandle);
+          this.offsetX = (pointer[0] - offsets[0]);
+          this.offsetY = (pointer[1] - offsets[1]);
+        }
+      }
+      Event.stop(event);
+    }
+  },
+  update: function(event) {
+   if(this.active) {
+      if(!this.dragging) this.dragging = true;
+      this.draw(event);
+      // fix AppleWebKit rendering
+      if(navigator.appVersion.indexOf('AppleWebKit')>0) window.scrollBy(0,0);
+      Event.stop(event);
+   }
+  },
+  draw: function(event) {
+    var pointer = [Event.pointerX(event), Event.pointerY(event)];
+    var offsets = Position.cumulativeOffset(this.track);
+    pointer[0] -= this.offsetX + offsets[0];
+    pointer[1] -= this.offsetY + offsets[1];
+    this.event = event;
+    this.setValue(this.translateToValue( this.isVertical() ? pointer[1] : pointer[0] ));
+    if(this.initialized && this.options.onSlide)
+      this.options.onSlide(this.values.length>1 ? this.values : this.value, this);
+  },
+  endDrag: function(event) {
+    if(this.active && this.dragging) {
+      this.finishDrag(event, true);
+      Event.stop(event);
+    }
+    this.active = false;
+    this.dragging = false;
+  },  
+  finishDrag: function(event, success) {
+    this.active = false;
+    this.dragging = false;
+    this.updateFinished();
+  },
+  updateFinished: function() {
+    if(this.initialized && this.options.onChange) 
+      this.options.onChange(this.values.length>1 ? this.values : this.value, this);
+    this.event = null;
+  }
+}
\ No newline at end of file
Index: lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/cssQuery/src/cssQuery-level3.js
===================================================================
--- lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/cssQuery/src/cssQuery-level3.js	(nonexistent)
+++ lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/lib/cssQuery/src/cssQuery-level3.js	(revision 4307)
@@ -0,0 +1,150 @@
+/*
+	cssQuery, version 2.0.2 (2005-08-19)
+	Copyright: 2004-2005, Dean Edwards (http://dean.edwards.name/)
+	License: http://creativecommons.org/licenses/LGPL/2.1/
+*/
+
+/* Thanks to Bill Edney */
+
+cssQuery.addModule("css-level3", function() {
+
+// -----------------------------------------------------------------------
+// selectors
+// -----------------------------------------------------------------------
+
+// indirect sibling selector
+selectors["~"] = function($results, $from, $tagName, $namespace) {
+	var $element, i;
+	for (i = 0; ($element = $from[i]); i++) {
+		while ($element = nextElementSibling($element)) {
+			if (compareTagName($element, $tagName, $namespace))
+				$results.push($element);
+		}
+	}
+};
+
+// -----------------------------------------------------------------------
+// pseudo-classes
+// -----------------------------------------------------------------------
+
+// I'm hoping these pseudo-classes are pretty readable. Let me know if
+//  any need explanation.
+
+pseudoClasses["contains"] = function($element, $text) {
+	$text = new RegExp(regEscape(getText($text)));
+	return $text.test(getTextContent($element));
+};
+
+pseudoClasses["root"] = function($element) {
+	return $element == getDocument($element).documentElement;
+};
+
+pseudoClasses["empty"] = function($element) {
+	var $node, i;
+	for (i = 0; ($node = $element.childNodes[i]); i++) {
+		if (thisElement($node) || $node.nodeType == 3) return false;
+	}
+	return true;
+};
+
+pseudoClasses["last-child"] = function($element) {
+	return !nextElementSibling($element);
+};
+
+pseudoClasses["only-child"] = function($element) {
+	$element = $element.parentNode;
+	return firstElementChild($element) == lastElementChild($element);
+};
+
+pseudoClasses["not"] = function($element, $selector) {
+	var $negated = cssQuery($selector, getDocument($element));
+	for (var i = 0; i < $negated.length; i++) {
+		if ($negated[i] == $element) return false;
+	}
+	return true;
+};
+
+pseudoClasses["nth-child"] = function($element, $arguments) {
+	return nthChild($element, $arguments, previousElementSibling);
+};
+
+pseudoClasses["nth-last-child"] = function($element, $arguments) {
+	return nthChild($element, $arguments, nextElementSibling);
+};
+
+pseudoClasses["target"] = function($element) {
+	return $element.id == location.hash.slice(1);
+};
+
+// UI element states
+
+pseudoClasses["checked"] = function($element) {
+	return $element.checked;
+};
+
+pseudoClasses["enabled"] = function($element) {
+	return $element.disabled === false;
+};
+
+pseudoClasses["disabled"] = function($element) {
+	return $element.disabled;
+};
+
+pseudoClasses["indeterminate"] = function($element) {
+	return $element.indeterminate;
+};
+
+// -----------------------------------------------------------------------
+//  attribute selector tests
+// -----------------------------------------------------------------------
+
+AttributeSelector.tests["^="] = function($attribute, $value) {
+	return "/^" + regEscape($value) + "/.test(" + $attribute + ")";
+};
+
+AttributeSelector.tests["$="] = function($attribute, $value) {
+	return "/" + regEscape($value) + "$/.test(" + $attribute + ")";
+};
+
+AttributeSelector.tests["*="] = function($attribute, $value) {
+	return "/" + regEscape($value) + "/.test(" + $attribute + ")";
+};
+
+// -----------------------------------------------------------------------
+//  nth child support (Bill Edney)
+// -----------------------------------------------------------------------
+
+function nthChild($element, $arguments, $traverse) {
+	switch ($arguments) {
+		case "n": return true;
+		case "even": $arguments = "2n"; break;
+		case "odd": $arguments = "2n+1";
+	}
+
+	var $$children = childElements($element.parentNode);
+	function _checkIndex($index) {
+		var $index = ($traverse == nextElementSibling) ? $$children.length - $index : $index - 1;
+		return $$children[$index] == $element;
+	};
+
+	//	it was just a number (no "n")
+	if (!isNaN($arguments)) return _checkIndex($arguments);
+
+	$arguments = $arguments.split("n");
+	var $multiplier = parseInt($arguments[0]);
+	var $step = parseInt($arguments[1]);
+
+	if ((isNaN($multiplier) || $multiplier == 1) && $step == 0) return true;
+	if ($multiplier == 0 && !isNaN($step)) return _checkIndex($step);
+	if (isNaN($step)) $step = 0;
+
+	var $count = 1;
+	while ($element = $traverse($element)) $count++;
+
+	if (isNaN($multiplier) || $multiplier == 1)
+		return ($traverse == nextElementSibling) ? ($count <= $step) : ($step >= $count);
+
+	return ($count % $multiplier) == $step;
+};
+
+}); // addModule
Index: lib/spatial/mapbuilder/lib/model/Config.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/Config.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/Config.js	(revision 4307)
@@ -1,8 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Config.js 3893 2008-02-29 18:22:13Z ahocevar $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * The config object is the parent model of all mapbuilder objects.
  * The application creates a global object called 'config' which represents
@@ -25,14 +28,24 @@
   this.doc = Sarissa.getDomDocument();
   this.doc.async = false;
   this.doc.validateOnParse=false;  //IE6 SP2 parsing bug
+  if(_SARISSA_IS_SAFARI)
+  {
+  var xmlhttp = new XMLHttpRequest();
+  xmlhttp.open("GET", url, false);
+  xmlhttp.send(null);
+  this.doc = xmlhttp.responseXML;
+  }else
+   {
   this.doc.load(url);
-  if (this.doc.parseError < 0){
+  }
+  if (Sarissa.getParseErrorText(this.doc) != Sarissa.PARSED_OK){
     alert("error loading config document: " + url );//+ " - " + Sarissa.getParseErrorText(this.doc) );
   }
   this.url = url;
   this.namespace = "xmlns:mb='"+mbNsUrl+"'";
+  if(! _SARISSA_IS_SAFARI ){ 
   this.doc.setProperty("SelectionLanguage", "XPath");
-  Sarissa.setXpathNamespaces(this.doc, this.namespace);
+  Sarissa.setXpathNamespaces(this.doc, this.namespace);}
 
 /**
  * Set the serializeUrl and proxyUrl values from a global configuration document
@@ -41,16 +54,24 @@
   var configDoc = Sarissa.getDomDocument();
   configDoc.async = false;
   configDoc.validateOnParse=false;  //IE6 SP2 parsing bug
-  configDoc.load(baseDir+"/"+mbServerConfig);
-  if (configDoc.parseError < 0) {
+  if(_SARISSA_IS_SAFARI){
+    var xmlhttp = new XMLHttpRequest();
+    xmlhttp.open("GET", baseDir+"/"+mbServerConfig, false);
+    xmlhttp.send(null);
+    configDoc = xmlhttp.responseXML;
+  }else
+   {
+    configDoc.load(baseDir+"/"+mbServerConfig);
+   }
+  if (Sarissa.getParseErrorText(configDoc) != Sarissa.PARSED_OK) {
     //alert("error loading server config document: " + baseDir+"/"+mbServerConfig );
   } else {
+  if(! _SARISSA_IS_SAFARI ){
     configDoc.setProperty("SelectionLanguage", "XPath");
     Sarissa.setXpathNamespaces(configDoc, this.namespace);
-    var node = configDoc.selectSingleNode("/mb:MapbuilderConfig/mb:proxyUrl");
-    if (node) this.proxyUrl = node.firstChild.nodeValue;
-    node = configDoc.selectSingleNode("/mb:MapbuilderConfig/mb:serializeUrl");
-    if (node) this.serializeUrl = node.firstChild.nodeValue;
+    }
+    this.proxyUrl = Mapbuilder.getProperty(configDoc, "/mb:MapbuilderConfig/mb:proxyUrl", this.proxyUrl);
+    this.serializeUrl = Mapbuilder.getProperty(configDoc, "/mb:MapbuilderConfig/mb:serializeUrl", this.serializeUrl);
   }
   configDoc = null;
 
@@ -59,6 +80,14 @@
    * @private
    */
   this.loadConfigScripts=function(){
+    // load css stylesheets that were requested before skindir was known.
+    if (mapbuilder.cssToLoad) {
+      for (var i=0; i<mapbuilder.cssToLoad.length; i++) {
+        loadCss(mapbuilder.cssToLoad[i]);
+      }
+      mapbuilder.cssToLoad = null;
+    }
+    
     // Load script files for all components that don't have <scriptfile> specified
     // in the config file.
     mapbuilder.loadScriptsFromXpath(this.doc.selectNodes("//mb:models/*"),"model/");
@@ -70,7 +99,7 @@
     //problem if this is done anywhere except in the page <HEAD> element.
     var scriptFileNodes = this.doc.selectNodes("//mb:scriptFile");
     for (var i=0; i<scriptFileNodes.length; i++ ) {
-      scriptFile = scriptFileNodes[i].firstChild.nodeValue;
+      scriptFile = getNodeValue(scriptFileNodes[i]);
       mapbuilder.loadScript(scriptFile);
     }
   }
@@ -81,7 +110,8 @@
   * or by setting a global "language" Javascript variable in the page <HEAD>.
   * Retrieve the language value from the global conifg object as "config.lang"
   */
-  this.lang = "en";
+  this.defaultLang = "en";
+  this.lang = this.defaultLang;
   if (window.cgiArgs["language"]) {
     this.lang = window.cgiArgs["language"];
   } else if (window.language) {
@@ -90,25 +120,98 @@
 
   //set some global application properties
   var modelNode = this.doc.documentElement;
-  this.skinDir = modelNode.selectSingleNode("mb:skinDir").firstChild.nodeValue;
-  var proxyUrl = modelNode.selectSingleNode("mb:proxyUrl");
-  if (proxyUrl) this.proxyUrl = proxyUrl.firstChild.nodeValue;
-  var serializeUrl = modelNode.selectSingleNode("mb:serializeUrl");
-  if (serializeUrl) this.serializeUrl = serializeUrl.firstChild.nodeValue;
+  this.skinDir = Mapbuilder.getProperty(modelNode, "mb:skinDir");
+  this.proxyUrl = Mapbuilder.getProperty(modelNode, "mb:proxyUrl", this.proxyUrl);
+  this.serializeUrl = Mapbuilder.getProperty(modelNode, "mb:serializeUrl", this.serializeUrl);
 
-  var widgetText = modelNode.selectSingleNode("mb:widgetTextUrl");
-  if (widgetText) {
-    var widgetTextUrl = this.skinDir + "/" + this.lang + "/" + widgetText.firstChild.nodeValue;
-    this.widgetText = Sarissa.getDomDocument();
-    this.widgetText.async = false;
-    this.widgetText.validateOnParse=false;  //IE6 SP2 parsing bug
-    this.widgetText.load(widgetTextUrl);
-    if (this.widgetText.parseError < 0){
-      alert("error loading widgetText document: " + widgetTextUrl );//+ " - " + Sarissa.getParseErrorText(this.doc) );
+  /**
+   * Convenience method to load widgetText from a dir.
+   * Has the possible side-effect of changing config.lang to config.defaultLang
+   * if the widgetText for the selected language is not found.
+   * @param config the config object
+   * @param dir    the base dir for the widget text
+   * @private
+   */
+  function loadWidgetText(config, dir) {
+    var widgetFile = "/widgetText.xml";
+    var widgetText;
+    var widgetTextUrl = dir + "/" + config.lang + widgetFile;
+    widgetText = Sarissa.getDomDocument();
+    widgetText.async = false;
+    widgetText.validateOnParse=false;  //IE6 SP2 parsing bug
+    
+    if (typeof(inlineXSL)!="undefined") {
+      var xmlString = inlineXSL[widgetTextUrl];
+      xmlString = xmlString.replace(/DOUBLE_QUOTE/g,"\"");
+      widgetText = (new DOMParser()).parseFromString(xmlString, "text/xml");
     }
-    this.widgetText.setProperty("SelectionLanguage", "XPath");
-    Sarissa.setXpathNamespaces(this.widgetText, this.namespace);
+    else {
+      if (_SARISSA_IS_SAFARI) {
+        var xmlhttp = new XMLHttpRequest();
+        xmlhttp.open("GET", widgetTextUrl, false);
+        xmlhttp.send(null);
+        widgetText = xmlhttp.responseXML;
+      }
+      else {
+        try {
+          widgetText.load(widgetTextUrl);
+        }
+        catch (ignoredErr) {}
+      }
+    }      
+    if (Sarissa.getParseErrorText(widgetText) != Sarissa.PARSED_OK) {
+      var errMsg = "Error loading widgetText document: " + widgetTextUrl;
+      if (config.lang == config.defaultLang) {
+        alert(errMsg);
+      }
+      else {
+        // Try to fall back on default language
+        alert(errMsg + "\nFalling back on default language=\"" + config.defaultLang + "\"");
+        config.lang = config.defaultLang;
+        widgetTextUrl = dir + "/" + config.lang + widgetFile;
+        if(_SARISSA_IS_SAFARI) {
+          var xmlhttp = new XMLHttpRequest();
+          xmlhttp.open("GET", widgetTextUrl, false);
+          xmlhttp.send(null);
+          widgetText = xmlhttp.responseXML;
+        }
+        else {
+          widgetText.load(widgetTextUrl);
+        }
+        if (Sarissa.getParseErrorText(widgetText) != Sarissa.PARSED_OK) {
+          alert("Falling back on default language failed!");
+        }
+      }
+    }
+    if(! _SARISSA_IS_SAFARI) {
+      widgetText.setProperty("SelectionLanguage", "XPath");
+      Sarissa.setXpathNamespaces(widgetText, config.namespace);
+    }
+    return widgetText;
   }
+  
+  // Load widgetText
+  this.widgetText = loadWidgetText(this, baseDir + "/text");
+  // Try to load userWidgetText
+  userWidgetTextDir = modelNode.selectSingleNode("mb:userWidgetTextDir");
+  if (userWidgetTextDir) {
+    var userWidgetText = loadWidgetText(this, getNodeValue(userWidgetTextDir));
+    if (userWidgetText) {
+      // User has specified userWidgetText, merge with widgetText
+      var userWidgets = userWidgetText.selectSingleNode("/mb:WidgetText/mb:widgets");
+      var configWidgets = this.widgetText.selectSingleNode("/mb:WidgetText/mb:widgets");
+      if (userWidgets && configWidgets) {
+        // Merge <widgets/> texts
+        Sarissa.copyChildNodes(userWidgets, configWidgets, true);
+      }
+      var userMessages = userWidgetText.selectSingleNode("/mb:WidgetText/mb:messages");
+      var configMessages = this.widgetText.selectSingleNode("/mb:WidgetText/mb:messages");
+      if (userMessages && configMessages) {
+        // Merge <messages/> texts
+        Sarissa.copyChildNodes(userMessages, configMessages, true);
+      }
+    }
+  }
 
   /**
   * the objects property holds a reference to every mapbuilder javascript object
@@ -135,7 +238,7 @@
       httpPayload.url = modelUrl;
       model.newRequest(model,httpPayload);
     } else {
-      alert("config loadModel error:"+modelId+":"+modelUrl);
+      alert(mbGetMessage("errorLoadingModel", modelId, modelUrl));
     }
   }
 
@@ -146,9 +249,9 @@
    */
   this.paintWidget = function( widget ) {
     if (widget) {
-      widget.paint(widget, true);
+      widget.paint(widget, widget.id);
     } else {
-      alert("config paintWidget error: widget does not exist");
+      alert(mbGetMessage("errorPaintingWidget"));
     }
   }
 }
Index: lib/spatial/mapbuilder/lib/model/WmsCapabilities.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/WmsCapabilities.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/WmsCapabilities.js	(revision 4307)
@@ -1,13 +1,17 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WmsCapabilities.js 3887 2008-02-27 18:18:53Z ahocevar $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a Web Map Server (WMS) Capabilities document as defined by the 
- * Open Geospatial Consortium (http://opengis.org and extensions the the WMC.  
+ * Open Geospatial Consortium (http://www.opengeospatial.org/) and extensions the the WMC.  
  *
  * @constructor
+ * @base ModelBase
  * @author Mike Adair
  * @param modelNode   The model's XML object node from the configuration document.
  * @param parent The model object that this widget belongs to.
@@ -62,8 +66,7 @@
    */
   this.getServerTitle = function() {
     var xpath = "/WMT_MS_Capabilities/Service/Title";
-    var node = this.doc.selectSingleNode(xpath);
-    return node.firstChild.nodeValue;
+    return Mapbuilder.getProperty(this.doc, xpath, "no title");
   }
 
   /**
@@ -82,8 +85,7 @@
 	  }
     } else {
       var xpath = "/WMT_MS_Capabilities/Capability/Request/GetMap/Format";
-      var node = this.doc.selectSingleNode(xpath);
-      return node.firstChild.nodeValue;
+      return Mapbuilder.getProperty(this.doc, xpath);
     }
   }
 
@@ -92,8 +94,7 @@
    */
   this.getServiceName = function() {
     var xpath = "/WMT_MS_Capabilities/Service/Name";
-    var node = this.doc.selectSingleNode(xpath);
-    return node.firstChild.nodeValue;
+    return Mapbuilder.getProperty(this.doc, xpath);
   }
 
   /**
